#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 *
 * MS-DOS COM G~[^ for Windows
 *                           ver 0.0.1
 *
 * Copyright (C) 2011  moge32
 *
 * ̃G~[^́AMS-DOSCOMt@CWindowsœ삳\tgłB
 * ܂G~[VɃoO{Ƃ͈Ⴄ_邩m܂B
 * Ƃ܂B
 *
 */

#define	R_AX	(reg[0])
#define	R_CX	(reg[1])
#define	R_DX	(reg[2])
#define	R_BX	(reg[3])
#define	R_AH	((R_AX&0xff00)/0x100)
#define	R_BH	((R_BX&0xff00)/0x100)
#define	R_CH	((R_CX&0xff00)/0x100)
#define	R_DH	((R_DX&0xff00)/0x100)
#define	R_AL	(R_AX&0x00ff)
#define	R_BL	(R_BX&0x00ff)
#define	R_CL	(R_CX&0x00ff)
#define	R_DL	(R_DX&0x00ff)

// 0:AX 1:CX 2:DX 3:BX 4:SP 5:BP 6:SI 7:DI
unsigned short reg[7];


#define		MOV_L_H		0x88
#define		MOV_X_X		0x89
#define		NOP			0x90
#define		MOV_AL		0xB0
#define		MOV_CL		0xB1
#define		MOV_DL		0xB2
#define		MOV_BL		0xB3
#define		MOV_AH		0xB4
#define		MOV_CH		0xB5
#define		MOV_DH		0xB6
#define		MOV_BH		0xB7
#define		MOV_AX		0xB8
#define		MOV_CX		0xB9
#define		MOV_DX		0xBA
#define		MOV_BX		0xBB
#define		RET			0xC3
#define		INT3		0xCC
#define		INT			0xCD
#define		JMP			0xEB
#define		HLT			0xF4
#define		CLI			0xFA
#define		STI			0xFB

#define		INT_END		0x20
#define		INT_API		0x21

void end(int num);
char parse(char *p);
void interrupt(char *call);
void msdos_api(char *p);
char pointer(short addr, char *p);

char filebuf[65536];

int main(int argc, char *argv[])
{
	FILE *fh;
	int fsize, i;
	char *p, cmdline[30];

	if (argc == 1) return 1;

	// IvVH
	if (!strcmp(argv[1], "-v")) {
		end(5);
		return 0;
	}

	// t@CJB
	fh = fopen(argv[1], "rb");

	if (fh != NULL) {							// t@CJ
		fsize = fread(filebuf, 1, 65536, fh);	// ׂĈCɓǂݍށB
		if (fsize >= 65536) {					// COMt@C̃t@CTCY𒴂Ă
			end(2);
		}
		fclose(fh);								// t@CB
	} else {									// t@CJȂIB
		end(0);
	}

	p = filebuf;

	while (1) {									// 1ByteĂB
		if (p == &filebuf[fsize]) break;		// EOF܂ŗIB
		i = parse(p);							// j[jbN͂B
		p = p + i;								// parse֐͉oCgi߂΂Ă̂ŁA̕vXB
	}

	return 0;
}

// bZ[WoďIB
void end(int num)
{
	printf("\n");
	if (num == 0) {
		printf("File not found.\n");
	}
	if (num == 1) {
		printf("Error.\n");
	}
	if (num == 2) {
		printf("COM file size over(64kB).\n");
	}
	if (num == 3) {
		printf("Unable to parse.\n");
	}
	if (num == 4) {
		printf("Program terminated normally\n");
	}
	if (num == 5) {
		printf("WinDOS() ver0.01\n Copyright (C) 2011  moge32\n");
		return;
	}

	// eXgpR[h
	printf("\nah:0x%02X,al:0x%02X,ax:0x%04X,dx:0x%04X\n\n", R_AH, R_AL, R_AX, R_DX);

	exit(0);
}

// @B(x86)́B
char parse(char *p)
{
	char tmp[1];
	short addr;

	if (*p == (char)NOP) {
		return 1;
	}
	if (*p == (char)MOV_AX) {
		R_AX = p[2] * 0x100 + p[1];
		return 2;
	}
	if (*p == (char)MOV_AH) {
		R_AX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_AL) {
		R_AX = R_AH + p[1] & 0x00ff;
		return 2;
	}

	if (*p == (char)MOV_BX) {
		R_BX = p[2] * 0x100 + p[1];
		return 2;
	}
	if (*p == (char)MOV_BH) {
		R_BX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_BL) {
		R_BX = R_BH + p[1] & 0x00ff;
		return 2;
	}

	if (*p == (char)MOV_CX) {
		R_CX = p[2] * 0x100 + p[1];
		return 2;
	}
	if (*p == (char)MOV_CH) {
		R_CX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_CL) {
		R_CX = R_CH + p[1] & 0x00ff;
		return 2;
	}

	if (*p == (char)MOV_DX) {
		R_DX = p[2] * 0x100 + p[1];
		return 2;
	}
	if (*p == (char)MOV_DH) {
		R_DX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_DL) {
		R_DX = R_DH + p[1] & 0x00ff;
		return 2;
	}
	if (*p == (char)MOV_X_X) {
		char next = p[1];
		if (next == (char) 0xC0) R_AX = R_AX;
		if (next == (char) 0xC1) R_CX = R_AX;
		if (next == (char) 0xC2) R_DX = R_AX;
		if (next == (char) 0xC3) R_BX = R_AX;
		if (next == (char) 0xC8) R_AX = R_CX;
		if (next == (char) 0xC9) R_CX = R_CX;
		if (next == (char) 0xCA) R_DX = R_CX;
		if (next == (char) 0xCB) R_BX = R_CX;
		if (next == (char) 0xD0) R_AX = R_DX;
		if (next == (char) 0xD1) R_CX = R_DX;
		if (next == (char) 0xD2) R_DX = R_DX;
		if (next == (char) 0xD3) R_BX = R_DX;
		if (next == (char) 0xD8) R_CX = R_BX;
		if (next == (char) 0xD9) R_AX = R_BX;
		if (next == (char) 0xDA) R_DX = R_BX;
		if (next == (char) 0xDB) R_BX = R_BX;
		return 2;
	}
	if (*p == (char)MOV_L_H) {
		char next = p[1];
		if (next == (char) 0xC0) R_AX = R_AH + R_AL;
		if (next == (char) 0xC1) R_CX = R_CH + R_AL;
		if (next == (char) 0xC2) R_DX = R_DH + R_AL;
		if (next == (char) 0xC3) R_BX = R_BH + R_AL;
		if (next == (char) 0xC8) R_AX = R_AH + R_CL;
		if (next == (char) 0xC9) R_CX = R_CH + R_CL;
		if (next == (char) 0xCA) R_DX = R_DH + R_CL;
		if (next == (char) 0xCB) R_BX = R_BH + R_CL;
		if (next == (char) 0xD0) R_AX = R_AH + R_DL;
		if (next == (char) 0xD1) R_CX = R_CH + R_DL;
		if (next == (char) 0xD2) R_DX = R_DH + R_DL;
		if (next == (char) 0xD3) R_BX = R_BH + R_DL;
		if (next == (char) 0xD9) R_CX = R_CH + R_BL;
		if (next == (char) 0xD8) R_AX = R_AH + R_BL;
		if (next == (char) 0xDA) R_DX = R_DH + R_BL;
		if (next == (char) 0xDB) R_BX = R_BH + R_BL;
		return 2;
	}
	/* H -> H
	88E4			MOV		AH,AH
	88FC			MOV		AH,BH
	88EC			MOV		AH,CH
	88F4			MOV		AH,DH
	88E7			MOV		BH,AH
	88FF			MOV		BH,BH
	88EF			MOV		BH,CH
	88F7			MOV		BH,DH
	88E5			MOV		CH,AH
	88FD			MOV		CH,BH
	88ED			MOV		CH,CH
	88F5			MOV		CH,DH
	88E6			MOV		DH,AH
	88FE			MOV		DH,BH
	88EE			MOV		DH,CH
	88F6			MOV		DH,DH
	*/
	/* L -> L
	88C0			MOV		AL,AL
	88D8			MOV		AL,BL
	88C8			MOV		AL,CL
	88D0			MOV		AL,DL
	88C3			MOV		BL,AL
	88DB			MOV		BL,BL
	88CB			MOV		BL,CL
	88D3			MOV		BL,DL
	88C1			MOV		CL,AL
	88D9			MOV		CL,BL
	88C9			MOV		CL,CL
	88D1			MOV		CL,DL
	88C2			MOV		DL,AL
	88DA			MOV		DL,BL
	88CA			MOV		DL,CL
	88D2			MOV		DL,DL
	*/
	/* H -> L
	88C4			MOV		AH,AL
	88DC			MOV		AH,BL
	88CC			MOV		AH,CL
	88D4			MOV		AH,DL
	88C7			MOV		BH,AL
	88DF			MOV		BH,BL
	88CF			MOV		BH,CL
	88D7			MOV		BH,DL
	88C5			MOV		CH,AL
	88DD			MOV		CH,BL
	88CD			MOV		CH,CL
	88D5			MOV		CH,DL
	88C6			MOV		DH,AL
	88DE			MOV		DH,BL
	88CE			MOV		DH,CL
	88D6			MOV		DH,DL
	*/
	if (*p == (char)INT3) {
		printf("msdos: [breakpoint]@int3");
		end(5);
	}
	if (*p == (char)INT) {
		interrupt(p + 1);
		return 2;
	}

	return 1;
}

// INT̏
void interrupt(char *call)
{
	// {Ȃ
	//  PUSH EFLAGS
	//  PUSH CS
	//  PUSH EIP
	//  CLI
	// 
	if (*call == INT_END){
		end(4);
	}
	if (*call == INT_API) {
		msdos_api(call);
	}
	return;
}

// INT 21Ă΂ꂽƂ̓
void msdos_api(char *p)
{
	int ah = R_AH;
	if (ah == 0x00) {
		end(4);
	}
	if (ah == 0x01) {
		int ch = getche();
		if (ch == EOF) return;
		R_AX = (short)(R_AH + (ch&0x00ff)) - 1;
	}
	if (ah == 0x02) {
		putchar(R_DL);
	}
	if (ah == 0x08) {
		int ch = getch();
		if (ch == EOF) return;
		R_AX = (short)(R_AH + (ch&0x00ff)) - 1;
	}
	if (ah == 0x09) {
		char *c = &filebuf[R_DX-0x100];
		while (1) {
			if (*c == '$') break;
			putchar((int)(*c));
			c++;
		}
	}
}

char pointer(short addr, char *p)
{
	return p[addr - 0x100];
}

void unknown()
{
	puts("WinDOS() CPU has encountered an illegal instruction.");
	return;
}

/* End of msdos.c */
